Index: branches/new_class_id/src/world_entities/npcs/repair_station.cc
===================================================================
--- branches/new_class_id/src/world_entities/npcs/repair_station.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/npcs/repair_station.cc	(revision 9709)
@@ -25,11 +25,8 @@
 
 #include "repair_station.h"
-#include "class_list.h"
 
-
-
-
-
-CREATE_FACTORY(RepairStation, CL_DOOR);
+#include "class_id.h"
+NewObjectListDefinitionID(RepairStation, CL_DOOR +1 );
+CREATE_FACTORY(RepairStation);
 
 
@@ -67,6 +64,5 @@
 RepairStation::RepairStation(const TiXmlElement* root)
 {
-
-  this->setClassID(CL_DOOR, "RepairStation");
+  this->registerObject(this, RepairStation::_objectList);
   this->scale = 1.0f;
 
Index: branches/new_class_id/src/world_entities/npcs/repair_station.h
===================================================================
--- branches/new_class_id/src/world_entities/npcs/repair_station.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/npcs/repair_station.h	(revision 9709)
@@ -27,4 +27,5 @@
 class RepairStation : public WorldEntity
 {
+  NewObjectListDeclaration(RepairStation);
   public:
     RepairStation ();
Index: branches/new_class_id/src/world_entities/npcs/space_turret.cc
===================================================================
--- branches/new_class_id/src/world_entities/npcs/space_turret.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/npcs/space_turret.cc	(revision 9709)
@@ -29,5 +29,7 @@
 #include "effects/explosion.h"
 
-CREATE_FACTORY(SpaceTurret, CL_SPACE_TURRET);
+#include "class_id.h"
+NewObjectListDefinitionID(SpaceTurret, CL_SPACE_TURRET);
+CREATE_FACTORY(SpaceTurret);
 
 /**
@@ -59,5 +61,5 @@
 void SpaceTurret::init()
 {
-  this->setClassID(CL_SPACE_TURRET, "SpaceTurret");
+  this->registerObject(this, SpaceTurret::_objectList);
   this->loadModel("models/ground_turret_#.obj", 7.5);
   this->loadModel("models/comet.obj", 1.0f, 3);
Index: branches/new_class_id/src/world_entities/npcs/space_turret.h
===================================================================
--- branches/new_class_id/src/world_entities/npcs/space_turret.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/npcs/space_turret.h	(revision 9709)
@@ -18,4 +18,5 @@
 class SpaceTurret : public NPC
 {
+  NewObjectListDeclaration(SpaceTurret);
 
 public:
Index: branches/new_class_id/src/world_entities/planet.cc
===================================================================
--- branches/new_class_id/src/world_entities/planet.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/planet.cc	(revision 9709)
@@ -32,7 +32,7 @@
 
 
-
-CREATE_FACTORY(Planet, CL_PLANET);
-
+#include "class_id.h"
+NewObjectListDefinitionID(Planet, CL_PLANET);
+CREATE_FACTORY(Planet);
 
 
@@ -42,5 +42,5 @@
 Planet::Planet(const TiXmlElement* root)
 {
-  this->setClassID(CL_PLANET, "Planet");
+  this->registerObject(this, Planet::_objectList);
   this->toList(OM_GROUP_01);
 
Index: branches/new_class_id/src/world_entities/planet.h
===================================================================
--- branches/new_class_id/src/world_entities/planet.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/planet.h	(revision 9709)
@@ -16,4 +16,6 @@
 class Planet : public WorldEntity
 {
+  NewObjectListDeclaration(Planet);
+
  public:
   Planet(const TiXmlElement* root);
Index: branches/new_class_id/src/world_entities/power_ups/laser_power_up.cc
===================================================================
--- branches/new_class_id/src/world_entities/power_ups/laser_power_up.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/power_ups/laser_power_up.cc	(revision 9709)
@@ -24,6 +24,7 @@
 
 
-
-CREATE_FACTORY(LaserPowerUp, CL_LASER_POWER_UP);
+#include "class_id.h"
+NewObjectListDefinitionID(LaserPowerUp, CL_LASER_POWER_UP);
+CREATE_FACTORY(LaserPowerUp);
 
 LaserPowerUp::LaserPowerUp () : PowerUp(0.0, 1.0, 0.0)
@@ -49,5 +50,5 @@
 void LaserPowerUp::init()
 {
-  this->setClassID(CL_LASER_POWER_UP, "LaserPowerUp");
+  this->registerObject(this, LaserPowerUp::_objectList);
   this->loadModel("models/guns/test_gun.obj", 2.0);
 
Index: branches/new_class_id/src/world_entities/power_ups/laser_power_up.h
===================================================================
--- branches/new_class_id/src/world_entities/power_ups/laser_power_up.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/power_ups/laser_power_up.h	(revision 9709)
@@ -13,4 +13,5 @@
 
 class LaserPowerUp : public PowerUp {
+  NewObjectListDeclaration(LaserPowerUp);
 
  public:
Index: branches/new_class_id/src/world_entities/power_ups/param_power_up.cc
===================================================================
--- branches/new_class_id/src/world_entities/power_ups/param_power_up.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/power_ups/param_power_up.cc	(revision 9709)
@@ -28,6 +28,6 @@
 
 #include "class_id.h"
-CREATE_FACTORY(ParamPowerUp, CL_PARAM_POWER_UP);
 NewObjectListDefinitionID(ParamPowerUp, CL_PARAM_POWER_UP);
+CREATE_FACTORY(ParamPowerUp);
 
 const char* ParamPowerUp::paramTypes[] = {
Index: branches/new_class_id/src/world_entities/power_ups/turret_power_up.cc
===================================================================
--- branches/new_class_id/src/world_entities/power_ups/turret_power_up.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/power_ups/turret_power_up.cc	(revision 9709)
@@ -24,6 +24,7 @@
 
 
-
-CREATE_FACTORY(TurretPowerUp, CL_TURRET_POWER_UP);
+#include "class_id.h"
+NewObjectListDefinitionID(TurretPowerUp, CL_TURRET_POWER_UP);
+CREATE_FACTORY(TurretPowerUp);
 
 TurretPowerUp::TurretPowerUp(const TiXmlElement* root) : PowerUp(0.0, 1.0, 0.0)
@@ -45,5 +46,5 @@
 void TurretPowerUp::init()
 {
-  this->setClassID(CL_TURRET_POWER_UP, "TurretPowerUp");
+  this->registerObject(this, TurretPowerUp::_objectList);
   this->loadModel("models/guns/turret1.obj", 2.0);
 
Index: branches/new_class_id/src/world_entities/power_ups/turret_power_up.h
===================================================================
--- branches/new_class_id/src/world_entities/power_ups/turret_power_up.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/power_ups/turret_power_up.h	(revision 9709)
@@ -13,4 +13,5 @@
 
 class TurretPowerUp : public PowerUp {
+  NewObjectListDeclaration(TurretPowerUp);
 
  public:
Index: branches/new_class_id/src/world_entities/power_ups/weapon_power_up.cc
===================================================================
--- branches/new_class_id/src/world_entities/power_ups/weapon_power_up.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/power_ups/weapon_power_up.cc	(revision 9709)
@@ -28,6 +28,6 @@
 
 #include "class_id.h"
-CREATE_FACTORY(WeaponPowerUp, CL_WEAPON_POWER_UP);
 NewObjectListDefinitionID(WeaponPowerUp, CL_WEAPON_POWER_UP);
+CREATE_FACTORY(WeaponPowerUp);
 
 WeaponPowerUp::WeaponPowerUp(const TiXmlElement* root) : PowerUp(1.0, 1.0, 0.0)
@@ -88,5 +88,5 @@
 {
   this->weapon = dynamic_cast<Weapon*>((weaponXML == NULL)
-      ? Factory::fabricate(static_cast<ClassID>(this->weapon->getLeafClassID()))
+      ? Factory::fabricate((this->weapon->getClassID()))
       : Factory::fabricate((const TiXmlElement*)this->getXmlElem()->FirstChildElement("weapon")));
   this->model = this->weapon->getModel(0);
Index: branches/new_class_id/src/world_entities/projectiles/bomb.cc
===================================================================
--- branches/new_class_id/src/world_entities/projectiles/bomb.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/projectiles/bomb.cc	(revision 9709)
@@ -25,5 +25,7 @@
 #include "debug.h"
 
-CREATE_FAST_FACTORY_STATIC(Bomb, CL_BOMB);
+#include "class_id.h"
+NewObjectListDefinitionID(Bomb, CL_BOMB);
+CREATE_FAST_FACTORY_STATIC(Bomb);
 
 /**
@@ -67,5 +69,5 @@
 void Bomb::init()
 {
-  this->setClassID(CL_BOMB, "Bomb");
+  this->registerObject(this, Bomb::_objectList);
 
 
@@ -173,4 +175,5 @@
 }
 
+
 void Bomb::deactivate()
 {
@@ -182,10 +185,11 @@
 void Bomb::detonate(float size)
 {
-  ObjectManager::EntityList detonationList;
-  ObjectManager::distanceFromObject(detonationList, *this, size, CL_NPC);
+  /// FIXME
+/*  ObjectManager::EntityList detonationList;
+  ObjectManager::distanceFromObject(detonationList, *this, size, NPC::objectList());
     while( !detonationList.empty() )
     {
       detonationList.front()->collidesWith(this, Vector(0,0,0));
       detonationList.pop_front();
-    }
+    }*/
 }
Index: branches/new_class_id/src/world_entities/projectiles/bomb.h
===================================================================
--- branches/new_class_id/src/world_entities/projectiles/bomb.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/projectiles/bomb.h	(revision 9709)
@@ -17,5 +17,5 @@
 class Bomb : public Projectile
 {
-
+  NewObjectListDeclaration(Bomb);
  public:
   Bomb(const TiXmlElement* root = NULL);
Index: branches/new_class_id/src/world_entities/projectiles/boomerang_projectile.cc
===================================================================
--- branches/new_class_id/src/world_entities/projectiles/boomerang_projectile.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/projectiles/boomerang_projectile.cc	(revision 9709)
@@ -20,5 +20,4 @@
 
 #include "state.h"
-#include "class_list.h"
 
 #include "dot_emitter.h"
@@ -27,5 +26,7 @@
 #include "debug.h"
 
-CREATE_FAST_FACTORY_STATIC(BoomerangProjectile, CL_BOOMERANG_PROJECTILE);
+#include "class_id.h"
+NewObjectListDefinitionID(BoomerangProjectile, CL_BOOMERANG_PROJECTILE);
+CREATE_FAST_FACTORY_STATIC(BoomerangProjectile);
 
 /**
@@ -34,5 +35,5 @@
 BoomerangProjectile::BoomerangProjectile () : Projectile()
 {
-  this->setClassID(CL_BOOMERANG_PROJECTILE, "BoomerangProjectile");
+  this->registerObject(this, BoomerangProjectile::_objectList);
 
   this->loadModel("models/projectiles/orx-rocket.obj", 2.0);
@@ -60,13 +61,13 @@
 
   /* this is normaly done by World.cc by deleting the ParticleEngine */
-  if (BoomerangProjectile::trailParticles != NULL && ClassList::getList(CL_BOOMERANG_PROJECTILE)->size() <= 1)
-  {
-    if (ClassList::exists(BoomerangProjectile::trailParticles, CL_PARTICLE_SYSTEM))
+  if (BoomerangProjectile::trailParticles != NULL && BoomerangProjectile::objectList().size() <= 1)
+  {
+    if (ParticleSystem::objectList().exists(BoomerangProjectile::trailParticles))
       delete BoomerangProjectile::trailParticles;
     BoomerangProjectile::trailParticles = NULL;
   }
-  if (BoomerangProjectile::explosionParticles != NULL && ClassList::getList(CL_BOOMERANG_PROJECTILE)->size() <= 1)
-  {
-    if (ClassList::exists(BoomerangProjectile::explosionParticles, CL_PARTICLE_SYSTEM))
+  if (BoomerangProjectile::explosionParticles != NULL && BoomerangProjectile::objectList().size() <= 1)
+  {
+    if (ParticleSystem::objectList().exists(BoomerangProjectile::explosionParticles))
       delete BoomerangProjectile::explosionParticles;
     BoomerangProjectile::explosionParticles = NULL;
Index: branches/new_class_id/src/world_entities/projectiles/boomerang_projectile.h
===================================================================
--- branches/new_class_id/src/world_entities/projectiles/boomerang_projectile.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/projectiles/boomerang_projectile.h	(revision 9709)
@@ -17,4 +17,5 @@
 class BoomerangProjectile : public Projectile
 {
+  NewObjectListDeclaration(BoomerangProjectile);
   public:
     BoomerangProjectile ();
Index: branches/new_class_id/src/world_entities/projectiles/guided_missile.cc
===================================================================
--- branches/new_class_id/src/world_entities/projectiles/guided_missile.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/projectiles/guided_missile.cc	(revision 9709)
@@ -19,5 +19,4 @@
 
 #include "state.h"
-#include "class_list.h"
 
 #include "dot_emitter.h"
@@ -26,5 +25,7 @@
 #include "debug.h"
 
-CREATE_FAST_FACTORY_STATIC(GuidedMissile, CL_GUIDED_MISSILE);
+#include "class_id.h"
+NewObjectListDefinitionID(GuidedMissile, CL_GUIDED_MISSILE);
+CREATE_FAST_FACTORY_STATIC(GuidedMissile);
 
 /**
@@ -33,5 +34,5 @@
 GuidedMissile::GuidedMissile () : Projectile()
 {
-  this->setClassID(CL_GUIDED_MISSILE, "GuidedMissile");
+  this->registerObject(this, GuidedMissile::_objectList);
 
   this->loadModel("models/projectiles/orx-rocket.obj", 2.0);
@@ -59,13 +60,13 @@
 
   /* this is normaly done by World.cc by deleting the ParticleEngine */
-  if (GuidedMissile::trailParticles != NULL && ClassList::getList(CL_GUIDED_MISSILE)->size() <= 1)
-  {
-    if (ClassList::exists(GuidedMissile::trailParticles, CL_PARTICLE_SYSTEM))
+  if (GuidedMissile::trailParticles != NULL && GuidedMissile::objectList().size() <= 1)
+  {
+    if (ParticleSystem::objectList().exists(GuidedMissile::trailParticles))
       delete GuidedMissile::trailParticles;
     GuidedMissile::trailParticles = NULL;
   }
-  if (GuidedMissile::explosionParticles != NULL && ClassList::getList(CL_GUIDED_MISSILE)->size() <= 1)
-  {
-    if (ClassList::exists(GuidedMissile::explosionParticles, CL_PARTICLE_SYSTEM))
+  if (GuidedMissile::explosionParticles != NULL && GuidedMissile::objectList().size() <= 1)
+  {
+    if (ParticleSystem::objectList().exists(GuidedMissile::explosionParticles))
       delete GuidedMissile::explosionParticles;
     GuidedMissile::explosionParticles = NULL;
Index: branches/new_class_id/src/world_entities/projectiles/guided_missile.h
===================================================================
--- branches/new_class_id/src/world_entities/projectiles/guided_missile.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/projectiles/guided_missile.h	(revision 9709)
@@ -16,4 +16,5 @@
 class GuidedMissile : public Projectile
 {
+  NewObjectListDeclaration(GuidedMissile);
   public:
     GuidedMissile ();
Index: branches/new_class_id/src/world_entities/projectiles/hyperblast.cc
===================================================================
--- branches/new_class_id/src/world_entities/projectiles/hyperblast.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/projectiles/hyperblast.cc	(revision 9709)
@@ -19,5 +19,4 @@
 
 #include "state.h"
-#include "class_list.h"
 
 #include "box_emitter.h"
@@ -26,5 +25,8 @@
 #include "debug.h"
 
-CREATE_FAST_FACTORY_STATIC(Hyperblast, CL_HYPERBLAST);
+#include "class_id.h"
+NewObjectListDefinitionID(Hyperblast, CL_HYPERBLAST);
+CREATE_FAST_FACTORY_STATIC(Hyperblast);
+
 
 /**
@@ -33,5 +35,5 @@
 Hyperblast::Hyperblast () : Projectile()
 {
-  this->setClassID(CL_HYPERBLAST, "Hyperblast");
+  this->registerObject(this, Hyperblast::_objectList);
 
   this->loadModel("models/projectiles/hyperblast.obj", 5);
@@ -55,5 +57,5 @@
 {
   /* this is normaly done by World.cc by deleting the ParticleEngine */
-  if (Hyperblast::explosionParticles != NULL && ClassList::getList(CL_HYPERBLAST)->size() <= 1)
+  if (Hyperblast::explosionParticles != NULL && Hyperblast::objectList().size() <= 1)
   {
     Hyperblast::explosionParticles = NULL;
Index: branches/new_class_id/src/world_entities/projectiles/hyperblast.h
===================================================================
--- branches/new_class_id/src/world_entities/projectiles/hyperblast.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/projectiles/hyperblast.h	(revision 9709)
@@ -17,4 +17,5 @@
 class Hyperblast : public Projectile
 {
+  NewObjectListDeclaration(Hyperblast);
   public:
     Hyperblast ();
Index: branches/new_class_id/src/world_entities/projectiles/laser.cc
===================================================================
--- branches/new_class_id/src/world_entities/projectiles/laser.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/projectiles/laser.cc	(revision 9709)
@@ -19,5 +19,4 @@
 
 #include "state.h"
-#include "class_list.h"
 #include "model.h"
 
@@ -29,6 +28,7 @@
 
 
-
-CREATE_FAST_FACTORY_STATIC(Laser, CL_LASER);
+#include "class_id.h"
+NewObjectListDefinition(Laser);
+CREATE_FAST_FACTORY_STATIC(Laser);
 
 /**
@@ -37,5 +37,5 @@
 Laser::Laser () : Projectile()
 {
-  this->setClassID(CL_LASER, "Laser");
+  this->registerObject(this, Laser::_objectList);
 
   this->loadModel("models/projectiles/laser.obj");
@@ -61,5 +61,5 @@
 
   /* this is normaly done by World.cc by deleting the ParticleEngine */
-  if (Laser::explosionParticles != NULL && ClassList::getList(CL_LASER)->size() <= 1)
+  if (Laser::explosionParticles != NULL && Laser::objectList().size() <= 1)
   {
     //if (ClassList::exists(Laser::explosionParticles, CL_PARTICLE_SYSTEM))
Index: branches/new_class_id/src/world_entities/projectiles/laser.h
===================================================================
--- branches/new_class_id/src/world_entities/projectiles/laser.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/projectiles/laser.h	(revision 9709)
@@ -17,4 +17,5 @@
 class Laser : public Projectile
 {
+  NewObjectListDeclaration(Laser);
   public:
     Laser ();
Index: branches/new_class_id/src/world_entities/projectiles/projectile.h
===================================================================
--- branches/new_class_id/src/world_entities/projectiles/projectile.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/projectiles/projectile.h	(revision 9709)
@@ -11,5 +11,5 @@
 
 #include "world_entity.h"
-#include "fast_factory.h"
+#include "loading/fast_factory.h"
 
 #include "sound_source.h"
Index: branches/new_class_id/src/world_entities/projectiles/rail_projectile.cc
===================================================================
--- branches/new_class_id/src/world_entities/projectiles/rail_projectile.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/projectiles/rail_projectile.cc	(revision 9709)
@@ -19,5 +19,4 @@
 
 #include "state.h"
-#include "class_list.h"
 #include "model.h"
 
@@ -29,6 +28,7 @@
 
 
-
-CREATE_FAST_FACTORY_STATIC(RailProjectile, CL_RAIL_PROJECTILE);
+#include "class_id.h"
+NewObjectListDefinitionID(RailProjectile, CL_RAIL_PROJECTILE);
+CREATE_FAST_FACTORY_STATIC(RailProjectile);
 
 /**
@@ -37,5 +37,5 @@
 RailProjectile::RailProjectile () : Projectile()
 {
-  this->setClassID(CL_RAIL_PROJECTILE, "RailProjectile");
+  this->registerObject(this, RailProjectile::_objectList);
 
   this->loadModel("models/projectiles/laser_projectile.obj", 100);
@@ -61,5 +61,5 @@
 
   /* this is normaly done by World.cc by deleting the ParticleEngine */
-  if (RailProjectile::explosionParticles != NULL && ClassList::getList(CL_RAIL_PROJECTILE)->size() <= 1)
+  if (RailProjectile::explosionParticles != NULL && RailProjectile::objectList().size() <= 1)
   {
     //if (ClassList::exists(RailProjectile::explosionParticles, CL_PARTICLE_SYSTEM))
Index: branches/new_class_id/src/world_entities/projectiles/rail_projectile.h
===================================================================
--- branches/new_class_id/src/world_entities/projectiles/rail_projectile.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/projectiles/rail_projectile.h	(revision 9709)
@@ -17,4 +17,5 @@
 class RailProjectile : public Projectile
 {
+  NewObjectListDeclaration(RailProjectile);
   public:
     RailProjectile ();
Index: branches/new_class_id/src/world_entities/projectiles/rocket.cc
===================================================================
--- branches/new_class_id/src/world_entities/projectiles/rocket.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/projectiles/rocket.cc	(revision 9709)
@@ -19,5 +19,4 @@
 
 #include "state.h"
-#include "class_list.h"
 
 #include "dot_emitter.h"
@@ -26,5 +25,7 @@
 #include "debug.h"
 
-CREATE_FAST_FACTORY_STATIC(Rocket, CL_ROCKET);
+#include "class_id.h"
+NewObjectListDefinitionID(Rocket, CL_ROCKET);
+CREATE_FAST_FACTORY_STATIC(Rocket);
 
 /**
@@ -33,5 +34,5 @@
 Rocket::Rocket () : Projectile()
 {
-  this->setClassID(CL_ROCKET, "Rocket");
+  this->registerObject(this, Rocket::_objectList);
 
   this->loadModel("models/projectiles/orx-rocket.obj", .3);
@@ -55,5 +56,5 @@
 
   /* this is normaly done by World.cc by deleting the ParticleEngine */
-  if (Rocket::trailParticles != NULL && ClassList::getList(CL_ROCKET)->size() <= 1)
+  if (Rocket::trailParticles != NULL && Rocket::objectList().size() <= 1)
   {
 /*    if (ClassList::exists(Rocket::trailParticles, CL_PARTICLE_SYSTEM))
@@ -61,5 +62,5 @@
     Rocket::trailParticles = NULL;
   }
-  if (Rocket::explosionParticles != NULL && ClassList::getList(CL_ROCKET)->size() <= 1)
+  if (Rocket::explosionParticles != NULL && Rocket::objectList().size() <= 1)
   {
 /*    if (ClassList::exists(Rocket::explosionParticles, CL_PARTICLE_SYSTEM))
Index: branches/new_class_id/src/world_entities/projectiles/rocket.h
===================================================================
--- branches/new_class_id/src/world_entities/projectiles/rocket.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/projectiles/rocket.h	(revision 9709)
@@ -9,6 +9,4 @@
 #include "projectile.h"
 
-class Vector;
-class Weapon;
 class SpriteParticles;
 class ParticleEmitter;
@@ -17,29 +15,31 @@
 class Rocket : public Projectile
 {
-  public:
-    Rocket ();
-    virtual ~Rocket ();
+  NewObjectListDeclaration(Rocket);
+
+public:
+  Rocket ();
+  virtual ~Rocket ();
 
 
-    virtual void activate();
-    virtual void deactivate();
+  virtual void activate();
+  virtual void deactivate();
 
-    virtual void collidesWith(WorldEntity* entity, const Vector& location);
+  virtual void collidesWith(WorldEntity* entity, const Vector& location);
 
-    virtual void destroy (WorldEntity* killer);
+  virtual void destroy (WorldEntity* killer);
 
-    virtual void tick (float time);
-    virtual void draw () const;
+  virtual void tick (float time);
+  virtual void draw () const;
 
 
-  private:
-    static FastFactory*               fastFactory;
-    static SpriteParticles*           trailParticles;
-    static SpriteParticles*           explosionParticles;
+private:
+  static FastFactory*               fastFactory;
+  static SpriteParticles*           trailParticles;
+  static SpriteParticles*           explosionParticles;
 
-    ParticleEmitter*                  emitter;
+  ParticleEmitter*                  emitter;
 
 
-    WorldEntity* hitEntity; // FIXME TEMPORARY
+  WorldEntity* hitEntity; // FIXME TEMPORARY
 
 };
Index: branches/new_class_id/src/world_entities/projectiles/test_bullet.cc
===================================================================
--- branches/new_class_id/src/world_entities/projectiles/test_bullet.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/projectiles/test_bullet.cc	(revision 9709)
@@ -19,5 +19,4 @@
 
 #include "state.h"
-#include "class_list.h"
 
 #include "dot_emitter.h"
@@ -25,5 +24,7 @@
 #include "debug.h"
 
-CREATE_FAST_FACTORY_STATIC(TestBullet, CL_TEST_BULLET);
+#include "class_id.h"
+NewObjectListDefinitionID(TestBullet, CL_TEST_BULLET);
+CREATE_FAST_FACTORY_STATIC(TestBullet);
 
 /**
@@ -32,5 +33,5 @@
 TestBullet::TestBullet () : Projectile()
 {
-  this->setClassID(CL_TEST_BULLET, "TestBullet");
+  this->registerObject(this, TestBullet::_objectList);
 
   this->loadModel("models/projectiles/orx-rocket.obj", .3);
@@ -54,13 +55,13 @@
 
   /* this is normaly done by World.cc by deleting the ParticleEngine */
-  if (TestBullet::trailParticles != NULL && ClassList::getList(CL_TEST_BULLET)->size() <= 1)
+  if (TestBullet::trailParticles != NULL && TestBullet::objectList().size() <= 1)
   {
-    if (ClassList::exists(TestBullet::trailParticles, CL_PARTICLE_SYSTEM))
+    if (ParticleSystem::objectList().exists(TestBullet::trailParticles))
       delete TestBullet::trailParticles;
     TestBullet::trailParticles = NULL;
   }
-  if (TestBullet::explosionParticles != NULL && ClassList::getList(CL_TEST_BULLET)->size() <= 1)
+  if (TestBullet::explosionParticles != NULL && TestBullet::objectList().size() <= 1)
   {
-    if (ClassList::exists(TestBullet::explosionParticles, CL_PARTICLE_SYSTEM))
+    if (ParticleSystem::objectList().exists(TestBullet::explosionParticles))
       delete TestBullet::explosionParticles;
     TestBullet::explosionParticles = NULL;
Index: branches/new_class_id/src/world_entities/projectiles/test_bullet.h
===================================================================
--- branches/new_class_id/src/world_entities/projectiles/test_bullet.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/projectiles/test_bullet.h	(revision 9709)
@@ -17,4 +17,6 @@
 class TestBullet : public Projectile
 {
+  NewObjectListDeclaration(TestBullet);
+
   public:
     TestBullet ();
Index: branches/new_class_id/src/world_entities/recorder.cc
===================================================================
--- branches/new_class_id/src/world_entities/recorder.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/recorder.cc	(revision 9709)
@@ -22,11 +22,12 @@
 
 
-
-CREATE_FACTORY(Recorder, CL_RECORDER);
+#include "class_id.h"
+NewObjectListDefinitionID(Recorder, CL_RECORDER);
+CREATE_FACTORY(Recorder);
 
 
 Recorder::Recorder (const TiXmlElement* root)
 {
-  this->setClassID(CL_RECORDER, "Recorder");
+  this->registerObject(this, Recorder::_objectList);
 
   // initialize libavcodec, and register all codecs and formats
Index: branches/new_class_id/src/world_entities/recorder.h
===================================================================
--- branches/new_class_id/src/world_entities/recorder.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/recorder.h	(revision 9709)
@@ -20,4 +20,5 @@
 class Recorder : public WorldEntity
 {
+  NewObjectListDeclaration(Recorder);
   public:
     Recorder (const TiXmlElement* root = NULL);
Index: branches/new_class_id/src/world_entities/satellite.cc
===================================================================
--- branches/new_class_id/src/world_entities/satellite.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/satellite.cc	(revision 9709)
@@ -21,8 +21,9 @@
 
 #include "objModel.h"
-#include "vector.h"
 
 
 
+
+NewObjectListDefinition(Satellite);
 
 /**
@@ -31,5 +32,5 @@
 Satellite::Satellite (Vector axis, float speed)
 {
-  this->setClassID(CL_SATELLITE, "Satellite");
+  this->registerObject(this, Satellite::_objectList);
 
   this->loadModel("cube");
Index: branches/new_class_id/src/world_entities/satellite.h
===================================================================
--- branches/new_class_id/src/world_entities/satellite.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/satellite.h	(revision 9709)
@@ -19,5 +19,5 @@
 class Satellite : public WorldEntity
 {
-  friend class World;
+  NewObjectListDeclaration(Satellite);
 
  public:
Index: branches/new_class_id/src/world_entities/script_trigger.cc
===================================================================
--- branches/new_class_id/src/world_entities/script_trigger.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/script_trigger.cc	(revision 9709)
@@ -16,11 +16,11 @@
 
 #include "script_trigger.h"
-#include "class_list.h"
 #include "script.h"
 
 #include "state.h"
 
-
-CREATE_SCRIPTABLE_CLASS(ScriptTrigger, CL_SCRIPT_TRIGGER,
+NewObjectListDefinition(ScriptTrigger);
+
+CREATE_SCRIPTABLE_CLASS(ScriptTrigger, ScriptTrigger::classID(),
             // Coordinates
              addMethod("setAbsCoor", ExecutorLua3<PNode,float,float,float>(&PNode::setAbsCoor))
@@ -49,6 +49,6 @@
  */
 ScriptTrigger::ScriptTrigger(const TiXmlElement* root)
-{ 
-  this->setClassID(CL_SCRIPT_TRIGGER, "ScriptTrigger");
+{
+  this->registerObject(this, ScriptTrigger::_objectList);
   this->toList(OM_COMMON);
 
@@ -139,9 +139,9 @@
 void ScriptTrigger::setTarget(const std::string& target)
 {
-  BaseObject* targetEntity = ClassList::getObject(target, CL_WORLD_ENTITY);
-
+
+  WorldEntity* targetEntity = WorldEntity::objectList().getObject(target);
   if (targetEntity != NULL)
   {
-    this->setTarget(dynamic_cast<WorldEntity*>(targetEntity));
+    this->setTarget(targetEntity);
   }
   else
@@ -157,9 +157,9 @@
 void ScriptTrigger::setTriggerParent(const std::string& parent)
 {
-  BaseObject* parentEntity = ClassList::getObject(parent, CL_WORLD_ENTITY);
+  WorldEntity* parentEntity = WorldEntity::objectList().getObject(parent);
 
   if (parentEntity != NULL)
   {
-    this->setParent(dynamic_cast<WorldEntity*>(parentEntity));
+    this->setParent(parentEntity);
     this->setParentMode(PNODE_MOVEMENT);
   }
Index: branches/new_class_id/src/world_entities/script_trigger.h
===================================================================
--- branches/new_class_id/src/world_entities/script_trigger.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/script_trigger.h	(revision 9709)
@@ -18,4 +18,5 @@
 class ScriptTrigger : public WorldEntity
 {
+  NewObjectListDeclaration(ScriptTrigger);
   public:
     ScriptTrigger(const TiXmlElement* root = NULL);
Index: branches/new_class_id/src/world_entities/skybox.cc
===================================================================
--- branches/new_class_id/src/world_entities/skybox.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/skybox.cc	(revision 9709)
@@ -31,6 +31,7 @@
 
 
-
-CREATE_FACTORY(SkyBox, CL_SKYBOX);
+#include "class_id.h"
+NewObjectListDefinitionID(SkyBox, CL_SKYBOX);
+CREATE_FACTORY(SkyBox);
 
 /**
@@ -72,5 +73,5 @@
 void SkyBox::preInit()
 {
-  this->setClassID(CL_SKYBOX, "SkyBox");
+  this->registerObject(this, SkyBox::_objectList);
   this->toList(OM_BACKGROUND);
   this->toReflectionList();
Index: branches/new_class_id/src/world_entities/skybox.h
===================================================================
--- branches/new_class_id/src/world_entities/skybox.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/skybox.h	(revision 9709)
@@ -27,5 +27,6 @@
 class SkyBox : public WorldEntity
 {
- public:
+  NewObjectListDeclaration(SkyBox);
+public:
   SkyBox(const std::string& fileName = "");
   SkyBox(const TiXmlElement* root);
Index: branches/new_class_id/src/world_entities/skydome.cc
===================================================================
--- branches/new_class_id/src/world_entities/skydome.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/skydome.cc	(revision 9709)
@@ -30,4 +30,5 @@
 
 
+NewObjectListDefinition(Skydome);
 
 /**
@@ -44,5 +45,5 @@
   PRINTF(0)("Skydome init\n");
 
-  this->setClassID(CL_SKYDOME, "Skydome");
+  this->registerObject(this, Skydome::_objectList);
   this->toList(OM_BACKGROUND);
   this->toReflectionList();
@@ -119,5 +120,5 @@
   glEnd();
 
-  WorldEntity::draw(); 
+  WorldEntity::draw();
 
   glPopMatrix();
Index: branches/new_class_id/src/world_entities/skydome.h
===================================================================
--- branches/new_class_id/src/world_entities/skydome.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/skydome.h	(revision 9709)
@@ -21,4 +21,5 @@
 class Skydome : public WorldEntity
 {
+  NewObjectListDeclaration(Skydome);
 public:
   Skydome();
@@ -31,13 +32,13 @@
   void generateSkyPlane(int divisions, float planetRadius, float atmosphereRadius,
                         float hTile, float vTile);
-  
+
   void setShader(Shader* shader);
   void setTexture(GLuint texture);
-  
+
   void activate();
   void deactivate();
 
 private:
-  
+
   typedef struct VertexInfo
   {
@@ -48,5 +49,5 @@
 
   bool activateDome;
-  
+
   VertexInfo *planeVertices;
   int numPlaneVertices;
@@ -59,5 +60,5 @@
   VertexInfo *vertices;
   int numVertices;
-  
+
   GLuint texture;
   Shader* shader;
